﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;

namespace Bioshock_string_manager
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        int unreal_index(ref int fdnum, byte[] all)
        {
            int result = 0;
            byte b0,
                    b1,
                    b2,
                    b3,
                    b4;

            b0 = all[fdnum++];
            if ((b0 & 0x40) != 0)
            {
                b1 = all[fdnum++];
                if ((b1 & 0x80) != 0)
                {
                    b2 = all[fdnum++];
                    if ((b2 & 0x80) != 0)
                    {
                        b3 = all[fdnum++];
                        if ((b3 & 0x80) != 0)
                        {
                            b4 = all[fdnum++];
                            result = b4;
                        }
                        result = (result << 7) | (b3 & 0x7f);
                    }
                    result = (result << 7) | (b2 & 0x7f);
                }
                result = (result << 7) | (b1 & 0x7f);
            }
            result = (result << 6) | (b0 & 0x3f);
            if ((b0 & 0x80) != 0)
                result = -result;
            return (result);
        }

        int make_unreal_index(int number, byte[] index_num)
        {
            int len = 0,
                    sign = 0;

            if (number < 0)
            {
                number = -number;
                sign = -1;
            }

            len++;
            index_num[0] = (byte)(number & 0x3f);
            number >>= 6;
            if (number != 0)
            {
                len++;
                index_num[0] += 0x40;
                index_num[1] = (byte)(number & 0x7f);
                number >>= 7;
                if (number != 0)
                {
                    len++;
                    index_num[1] += 0x80;
                    index_num[2] = (byte)(number & 0x7f);
                    number >>= 7;
                    if (number != 0)
                    {
                        len++;
                        index_num[2] += 0x80;
                        index_num[3] = (byte)(number & 0x7f);
                        number >>= 7;
                        if (number != 0)
                        {
                            len++;
                            index_num[3] += 0x80;
                            index_num[4] = (byte)number;
                        }
                    }
                }
            }
            if (sign != 0) index_num[0] += 0x80;
            return (len);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            OpenFileDialog op = new OpenFileDialog();
            if (op.ShowDialog() == DialogResult.OK)
            {
                byte[] all = File.ReadAllBytes(op.FileName);
                Directory.CreateDirectory(op.FileName+" EXT\\");
                for (int i = 0; i < all.Length; )
                {
                    int namesize = unreal_index(ref i, all)*2;
                    byte[] buf = new byte[namesize];
                    Array.Copy(all, i, buf, 0, namesize);
                    string stname = Encoding.Unicode.GetString(buf, 0, buf.Length-2);
                    i += namesize;
                    int datasize = unreal_index(ref i, all)*2;
                    buf = new byte[datasize];
                    Array.Copy(all, i, buf, 0, datasize-2);
                    File.WriteAllBytes(op.FileName + " EXT\\" + stname, buf);
                    i += datasize;
                }
                MessageBox.Show("Files extracted inside " + op.FileName + " EXT\\");
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            FolderBrowserDialog fold = new FolderBrowserDialog();
            if (fold.ShowDialog() == DialogResult.OK)
            {
                string path = fold.SelectedPath;
                string[] filelist = Directory.GetFiles(path);
                List<byte> nuovo = new List<byte>();
                int offsetcount = 0;
                for (int i = 0; i < filelist.Length; i++)
                {
                    string name = Path.GetFileName(filelist[i]);
                    if (name != "REBUILT.dat")
                    {
                        byte[] tempsize = new byte[5];
                        int count = make_unreal_index((name.Length + 1), tempsize);
                        for (int j = 0; j < count; j++)
                        {
                            nuovo.Add(tempsize[j]);
                        }
                        nuovo.AddRange(Encoding.Unicode.GetBytes(name));
                        nuovo.Add(0x0);
                        nuovo.Add(0x0);
                        byte[] data = File.ReadAllBytes(filelist[i]);
                        count = make_unreal_index(data.Length / 2, tempsize);
                        for (int j = 0; j < count; j++)
                        {
                            nuovo.Add(tempsize[j]);
                        }
                        nuovo.AddRange(data);
                    }
                    else
                        offsetcount = -1;
                }
                File.WriteAllBytes(path + "\\REBUILT.dat", nuovo.ToArray());
                MessageBox.Show(filelist.Length+offsetcount + " files repacked inside " + path + "\\REBUILT.dat");
            }
        }

    }
}
